/*=============================================================================
vitalnix/libaccdb - User Management Suite - Unified Account Database
accdb_int.h - Private include file for ACCDB back-end modules
  Copyright (C) Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2003
  -- License restrictions apply (Dual FAL/GPL2).
  -- For details see doc/FAL.txt and doc/GPL2.txt.
=============================================================================*/
#ifndef _ACCDB_INT_H
#define _ACCDB_INT_H 1

#ifndef __cplusplus
#  define MODULE_NAME(s) const char _module_name[] = (s);
#  define MODULE_DESC(s) const char _module_desc[] = (s);
#  define MODULE_INFO(s) const char _module_info[] = (s);
#else
#  define MODULE_NAME(s) extern "C" const char _module_name[] = (s);
#  define MODULE_DESC(s) extern "C" const char _module_desc[] = (s);
#  define MODULE_INFO(s) extern "C" const char _module_info[] = (s);
#endif

#ifdef __cplusplus
extern "C" {
#endif
  extern int q_open(void **);
  extern int q_usertrav(void *, struct accdb_user *);
  extern int q_userinfo(void *, struct accdb_user *, struct accdb_user *, size_t);
  extern int q_useradd(void *, struct accdb_user *);
  extern int q_usermod(void *, struct accdb_user *, struct accdb_user *);
  extern int q_userdel(void *, struct accdb_user *);
  extern int q_grouptrav(void *, struct accdb_group *);
  extern int q_groupinfo(void *, struct accdb_group *, struct accdb_group *, size_t);
  extern int q_groupadd(void *, struct accdb_group *);
  extern int q_groupmod(void *, struct accdb_group *, struct accdb_group *);
  extern int q_groupdel(void *, struct accdb_group *);
  extern int q_close(void *);
  extern int p_sysctl(unsigned int, ...);
#ifdef __cplusplus
};
#endif

#endif /* _ACCDB_INT_H */

//==[ End of file ]============================================================
