/*=============================================================================
vitalnix/accdb - User Management Suite - Unified Account Database
shared.c - Shared functions for the ACCDB system utilities
  Copyright (C) Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2003
  -- License restrictions apply (Dual FAL/GPL2).
  -- For details see doc/FAL.txt and doc/GPL2.txt.
=============================================================================*/
#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libHX.h>
#include "sysprog/shared.h"
#define MAXLNLEN 1024 /* max length for line buffer */

typedef unsigned char byte;

//-----------------------------------------------------------------------------
int Sh_count_args(const char **args) {
  int argk = 0;
  while(*args++ != NULL) { ++argk; }
  return argk;
}

void Sh_interactive(struct itab *qtabp) {
  char buf[MAXLNLEN];

  while(qtabp->fmt != NULL) {
    if(qtabp->type == 's') {
      char **ptr = qtabp->ptr;
      printf(qtabp->fmt, (*ptr != NULL) ? *ptr : "");
      fgets(buf, MAXLNLEN, stdin);
      HX_chomp(buf);
      if(strlen(buf) > 0) { HX_strclone(ptr, buf); }
    } else if(qtabp->type == 'd') {
      int *ptr = qtabp->ptr;
      printf(qtabp->fmt, (ptr != NULL) ? *ptr : 0);
      fgets(buf, MAXLNLEN, stdin);
      HX_chomp(buf);
      if(strlen(buf) > 0) { *ptr = strtol(buf, NULL, 0); }
    }

    if(!(qtabp->callback != NULL &&
     !qtabp->callback(qtabp->fmt, qtabp->type, qtabp->ptr))) {
      ++qtabp;
    }
  }

  return;
}

int Sh_only_digits(char *p) {
  if(p == NULL) { return 1; }
  while(*p != '\0') {
    if(!isdigit(*p++)) { return 0; }
  }
  return 1;
}

//==[ End of file ]============================================================
